# Number of pairs in an array with the sum greater than 0

Given an array **arr[]** of size **N**, the task is to find the number of distinct pairs in the array whose **sum is > 0**.

**Examples:**

Input:arr[] = { 3, -2, 1 }Output:2Explanation:

There are two pairs of elements in the array whose sum is positive. They are:

{3, -2} = 1

{3, 1} = 4

Input:arr[] = { -1, -1, -1, 0 }Output:0Explanation:

There are no pairs of elements in the array whose sum is positive.

**Naive Approach:** The naive approach for this problem is to consider all the unique pairs of elements in the array. For every pair, check if the sum is positive or not. **Time Complexity:** O(N^{2})

**Efficient Approach:**

- The idea is to use the concept of sorting and two pointer technique.
- For this problem, sorting is used because for the sum
**arr[i] + arr[j] > 0**where i, j are some random indices in the array, either**arr[i] > 0**or**arr[j] > 0**or both**arr[i] and arr[j] > 0**. - Therefore, once the array is sorted, since we need to find the unique pairs. For every ‘i’ such that
**arr[i] > 0**, we need to find the number of j’s such that**arr[j] + arr[j] > 0**. - Here, it is easy to find the count of pairs by using two pointer technique because the array is sorted. We just need to find the leftmost position of ‘j’ for which the condition holds true. This is found using the
**lower_bound of -arr[i] + 1**. - For example, let the array arr[] = {-4, 4, -5, 5, 3, -2, -3, -1, 2, 1}. This array is sorted. Therefore, the array becomes, {-5, -4, -3, -2, -1, 1, 2, 3, 4, 5}. For some random i, lets assume arr[i] = 4. Therefore, the index of -3 is found in the array which is 2. Now, we can be sure that for all the values between the indices 2 and 8, the value of arr[i] + arr[j] > 0.

Below is the implementation of the above approach:

## CPP

`// C++ program to find the` `// number of pairs in the` `// array with the sum > 0` `#include <bits/stdc++.h>` `using` `namespace` `std;` `// Function to find the number` `// of pairs in the array with` `// sum > 0` `int` `findNumOfPair(` `int` `* a, ` `int` `n)` `{` ` ` `// Sorting the given array` ` ` `sort(a, a + n);` ` ` `// Variable to store the count of pairs` ` ` `int` `ans = 0;` ` ` `// Loop to iterate through the array` ` ` `for` `(` `int` `i = 0; i < n; ++i) {` ` ` `// Ignore if the value is negative` ` ` `if` `(a[i] <= 0)` ` ` `continue` `;` ` ` `// Finding the index using lower_bound` ` ` `int` `j = lower_bound(a, a + n, -a[i] + 1) - a;` ` ` `// Finding the number of pairs between` ` ` `// two indices i and j` ` ` `ans += i - j;` ` ` `}` ` ` `return` `ans;` `}` `// Driver code` `int` `main()` `{` ` ` `int` `a[] = { 3, -2, 1 };` ` ` `int` `n = ` `sizeof` `(a) / ` `sizeof` `(a[0]);` ` ` `int` `ans = findNumOfPair(a, n);` ` ` `cout << ans << endl;` ` ` `return` `0;` `}` |

## Java

`// Java program to find the` `// number of pairs in the` `// array with the sum > 0` `import` `java.util.*;` `class` `GFG {` ` ` `// Function to find the number` ` ` `// of pairs in the array with` ` ` `// sum > 0` ` ` `static` `int` `findNumOfPair(` `int` `arr[], ` `int` `n)` ` ` `{` ` ` `// Sorting the given array` ` ` `Arrays.sort(arr);` ` ` `// Variable to store the count of pairs` ` ` `int` `ans = ` `0` `;` ` ` `// Loop to iterate through the array` ` ` `for` `(` `int` `i = ` `0` `; i < n; ++i) {` ` ` `// Ignore if the value is negative` ` ` `if` `(arr[i] <= ` `0` `)` ` ` `continue` `;` ` ` ` ` `/*` ` ` `minReqVal val is the min value ,which will` ` ` `give >=1 after adding with the arr[i]` ` ` `*/` ` ` `int` `minReqVal = -arr[i] + ` `1` `;` ` ` `int` `j = lower_bound(arr, minReqVal);` ` ` `if` `(j >= ` `0` `)` ` ` `ans += i - j;` ` ` `}` ` ` `return` `ans;` ` ` `}` ` ` `/*` ` ` `it return the index of a minimum Number in the` ` ` `array which is just >= val` ` ` `*/` ` ` `static` `int` `lower_bound(` `int` `arr[], ` `int` `val)` ` ` `{` ` ` `int` `start = ` `0` `, end = arr.length;` ` ` `/*` ` ` `using the Binary search technique , since our` ` ` `array is sorted` ` ` `*/` ` ` `while` `(start < end) {` ` ` `int` `mid = (start + end) >> ` `1` `;` ` ` `if` `(val > arr[mid])` ` ` `start = mid + ` `1` `;` ` ` `else` ` ` `end = mid;` ` ` `}` ` ` `// when we dont find the answer return -1` ` ` `if` `(start == arr.length)` ` ` `return` `-` `1` `;` ` ` `return` `start;` ` ` `}` ` ` `// Driver code` ` ` `public` `static` `void` `main(String[] args)` ` ` `{` ` ` `int` `a[] = {-` `2` `,-` `1` `,-` `1` `,-` `1` `,-` `1` `,` `0` `,` `1` `,` `2` `,` `3` `};` ` ` `int` `n = a.length;` ` ` `int` `ans = findNumOfPair(a, n);` ` ` `System.out.println(ans);` ` ` `}` `}` `// This code is contributed by Pradeep Mondal P` |

## Python3

`# Python3 program to find the` `# number of pairs in the` `# array with the sum > 0` `from` `bisect ` `import` `bisect_left as lower_bound` `# Function to find the number` `# of pairs in the array with` `# sum > 0` `def` `findNumOfPair(a, n):` ` ` `# Sorting the given array` ` ` `a ` `=` `sorted` `(a)` ` ` `# Variable to store the count of pairs` ` ` `ans ` `=` `0` ` ` `# Loop to iterate through the array` ` ` `for` `i ` `in` `range` `(n):` ` ` `# Ignore if the value is negative` ` ` `if` `(a[i] <` `=` `0` `):` ` ` `continue` ` ` `# Finding the index using lower_bound` ` ` `j ` `=` `lower_bound(a, ` `-` `a[i] ` `+` `1` `)` ` ` `# Finding the number of pairs between` ` ` `# two indices i and j` ` ` `ans ` `+` `=` `i ` `-` `j` ` ` `return` `ans` `# Driver code` `if` `__name__ ` `=` `=` `'__main__'` `:` ` ` `a ` `=` `[` `3` `, ` `-` `2` `, ` `1` `]` ` ` `n ` `=` `len` `(a)` ` ` `ans ` `=` `findNumOfPair(a, n)` ` ` `print` `(ans)` `# This code is contributed by mohit kumar 29` |

## C#

`// C# program to find the` `// number of pairs in the` `// array with the sum > 0` `using` `System;` `class` `GFG {` ` ` `// Function to find the number` ` ` `// of pairs in the array with` ` ` `// sum > 0` ` ` `static` `int` `findNumOfPair(` `int` `[] arr, ` `int` `n)` ` ` `{` ` ` `// Sorting the given array` ` ` `Array.Sort(arr);` ` ` `// Variable to store the count of pairs` ` ` `int` `ans = 0;` ` ` `// Loop to iterate through the array` ` ` `for` `(` `int` `i = 0; i < n; ++i) {` ` ` `// Ignore if the value is negative` ` ` `if` `(arr[i] <= 0)` ` ` `continue` `;` ` ` `/*` ` ` `minReqVal val is the min value ,which will` ` ` `give >=1 after adding with the arr[i]` ` ` `*/` ` ` `int` `minReqVal = -arr[i] + 1;` ` ` `int` `j = lower_bound(arr, minReqVal);` ` ` `if` `(j >= 0)` ` ` `ans += i - j;` ` ` `}` ` ` `return` `ans;` ` ` `}` ` ` `/*` ` ` `it return the index of a minimum Number in the` ` ` `array which is just >= val` ` ` `*/` ` ` `static` `int` `lower_bound(` `int` `[] arr, ` `int` `val)` ` ` `{` ` ` `int` `start = 0, end = arr.Length;` ` ` `/*` ` ` `using the Binary search technique , since our` ` ` `array is sorted` ` ` `*/` ` ` `while` `(start < end) {` ` ` `int` `mid = (start + end) >> 1;` ` ` `if` `(val > arr[mid])` ` ` `start = mid + 1;` ` ` `else` ` ` `end = mid;` ` ` `}` ` ` `// when we dont find the answer return -1` ` ` `if` `(start == arr.Length)` ` ` `return` `-1;` ` ` `return` `start;` ` ` `}` ` ` `// Driver code` ` ` `public` `static` `void` `Main()` ` ` `{` ` ` `int` `[] a = { -2, 1, 3 };` ` ` `int` `n = a.Length;` ` ` `int` `ans = findNumOfPair(a, n);` ` ` `Console.Write(ans);` ` ` `}` `}` `// This code is contributed by Pradeep Mondal P` |

## Javascript

`<script>` `// Javascript program to find the` `// number of pairs in the` `// array with the sum > 0` `// Function to find the number` ` ` `// of pairs in the array with` ` ` `// sum > 0` `function` `findNumOfPair(arr, n)` `{` ` ` `// Sorting the given array` ` ` `arr.sort(` `function` `(a,b){` `return` `a-b;});` ` ` ` ` `// Variable to store the count of pairs` ` ` `let ans = 0;` ` ` ` ` `// Loop to iterate through the array` ` ` `for` `(let i = 0; i < n; ++i) {` ` ` ` ` `// Ignore if the value is negative` ` ` `if` `(arr[i] <= 0)` ` ` `continue` `;` ` ` ` ` `/*` ` ` `minReqVal val is the min value ,which will` ` ` `give >=1 after adding with the arr[i]` ` ` `*/` ` ` `let minReqVal = -arr[i] + 1;` ` ` `let j = lower_bound(arr, minReqVal);` ` ` ` ` `if` `(j >= 0)` ` ` `ans += i - j;` ` ` `}` ` ` `return` `ans;` `}` `/*` ` ` `it return the index of a minimum Number in the` ` ` `array which is just >= val` ` ` `*/` `function` `lower_bound(arr,val)` `{` ` ` `let start = 0, end = arr.length;` ` ` ` ` `/*` ` ` `using the Binary search technique , since our` ` ` `array is sorted` ` ` `*/` ` ` `while` `(start < end) {` ` ` `let mid = (start + end) >> 1;` ` ` ` ` `if` `(val > arr[mid])` ` ` `start = mid + 1;` ` ` `else` ` ` `end = mid;` ` ` `}` ` ` ` ` `// when we dont find the answer return -1` ` ` `if` `(start == arr.length)` ` ` `return` `-1;` ` ` ` ` `return` `start;` `}` `// Driver code` `let a=[3, -2, 1];` `let n = a.length;` `let ans = findNumOfPair(a, n);` `document.write(ans);` `// This code is contributed by unknown2108` `</script>` |

**Output**

2

**Time Complexity:** O(N * log(N))